import DS from "ember-data";
 
var Book = DS.Model.extend({
  title: DS.attr('string'),
  author: DS.attr('string'),
  pubYear: DS.attr('string', {
    defaultValue: function() {
      return new Date().getFullYear();
    }
  }),
  purchaseDate: DS.attr('string', {
    defaultValue: function() {
      return new Date().toISOString().substring(0, 10);
    }
  }),
  note: DS.attr('string'),
  rating: DS.attr('number'),
  isbn: DS.attr('string'),
  wasRead: DS.attr('boolean', {
    defaultValue: function() {
      return false;
    }
  }),
  
  purchaseDateHumanReadable: function() {
    var purchaseDateComponents = (this.get('purchaseDate') || "").split('-');
    if(purchaseDateComponents.length === 3) {
      return "%@/%@/%@".fmt(purchaseDateComponents[1], purchaseDateComponents[2], purchaseDateComponents[0]);
    }
    return null;
  }.property('purchaseDate'),

  wasReadBool: function(key, value) {
    if(value !== undefined) {
      this.set('wasRead', value);
    }
    if(this.get('wasRead') === 'true' || this.get('wasRead') === true) {
      return true;
    } 
    return false;
  }.property('wasRead')

});

export default Book;
