import Ember from 'ember';

var BookRoute = Ember.Route.extend({
  
  actions: {
    delete: function(id) {
      // Make sure that you really want to delete it before doing it.
      var shouldDelete = confirm('Are you sure you want to delete this book?');
      if(shouldDelete) {
        this.store.find('book', id).then(function (book) {
          book.destroyRecord();
        });
        this.transitionTo('index');
      }
    }
  },
  
  model: function(params) {
    return this.store.find('book', params.book_id);
  },
  
  setupController: function(controller, model) {
    controller.set('content',      model)
              .set('isNotEditing', true)
              .set('isNotNew',     true);
              
  }
});

export default BookRoute;
