import Ember from 'ember';

var BookEditRoute = Ember.Route.extend({

  actions: {
    delete: function(id) {
      // Make sure that you really want to delete it before doing it.
      var shouldDelete = confirm('Are you sure you want to delete this book?');
      if(shouldDelete) {
        this.store.find('book', id).then(function (book) {
          book.destroyRecord();
        });
        this.transitionTo('index');
      }
    },
    
    save: function(id) {
      var self = this;
        this.store.find('book', id).then(function (book) {
          if (!book.get('isEmpty')) {
            book.save().then(function() {
              self.controller.set('isNotEditing', true);
              self.transitionTo('book.index', book.id);
            });           
          }
        });
    },

    willTransition: function(transition) {
      if(this.controller.get('content').get('isDirty') && !confirm("Are you sure you want to abandon your edits?")) {
        transition.abort();
      } else if(this.controller.get('content').get('isEmpty')) {
        alert("You cannot have an empty book. Please fill it at least a title.");
        transition.abort();
      } else {
        return true;
      }
    }
  },
    
  setupController: function(controller, model) {
    controller.set('content',      model)
              .set('isNotEditing', false)
              .set('isNotNew',     true);

  }

});

export default BookEditRoute;
