import Ember from 'ember';

var NewRoute = Ember.Route.extend({
  
  actions: {
    
    save: function(book) {
      var self = this;
      
      if (!book.get('isEmpty')) {
        book.save().then(function(book) {
          self.transitionTo('book', book.id);
        });
      } else {
        alert("You cannot have an empty book. Please fill it at least a title.");
      }
    },

    willTransition: function(transition) {
      if(this.controller.get('content').get('isDirty') && !confirm("Are you sure you want discard your new book?")) {
        transition.abort();
      } else {
        return true;
      }
    }
  },
  
  model: function() {
    return this.store.createRecord('book', {});
  },
  
  setupController: function(controller, model) {
    controller.set('content',      model)
              .set('isNotEditing', false)
              .set('isNotNew',     false);
  },
  
  renderTemplate: function(controller, model) {
    this.render('book', {
      controller: controller,
      model: model
    });
  }
});

export default NewRoute;
